<?php

namespace Drupal\edlp_search\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Core\Entity\EntityStorageInterface;
use Symfony\Component\HttpFoundation\Request;
use Drupal\Core\Form\FormBuilder;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * Class EdlpSearchController.
 */
class EdlpSearchController extends ControllerBase {

  /**
    * The form builder.
    *
    * @var \Drupal\Core\Form\FormBuilder
    */
   protected $formBuilder;

  /**
   * Construct.
   */
  public function __construct(FormBuilder $formBuilder) {
    $this->formBuilder = $formBuilder;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('form_builder')
    );
  }


  private function getSearchForm(){
    $this->form = $this->formBuilder->getForm('Drupal\edlp_search\Form\EdlpSearchForm');
  }

  private function buildRenderable(){
    $this->getSearchForm();
    $this->renderable = array(
      "#theme" => "edlp_search_search_form",
      '#form' => $this->form
    );
  }

  /**
   * Searchform.
   *
   * @return string
   *   Return Hello string.
   */
  public function searchForm() {
    $this->buildRenderable();

    return $this->renderable;
  }

  public function searchFormJson(){
    $this->buildRenderable();

    $rendered = render($this->renderable);

    $response = new JsonResponse();
    $response->setData([
      'rendered'=> $rendered,
    ]);
    return $response;

  }

  /**
   * Searchresults.
   *
   * @return string
   *   Return Hello string.
   */
  public function searchResults() {
    return [
      '#type' => 'markup',
      '#markup' => $this->t('Implement method: searchResults')
    ];
  }
  public function searchResultsJson(Request $request){

    $keys = $request->query->get('keys');

    $response = new JsonResponse();
    $response->setData([
      'test'=>'search results',
      'keys'=>$keys
      // 'rendered'=> $rendered,
    ]);
    return $response;
  }
}
